/*
  Copyright (c) 2013, Matthias Schiffer <mschiffer@universe-factory.net>
  All rights reserved.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions are met:

    1. Redistributions of source code must retain the above copyright notice,
       this list of conditions and the following disclaimer.
    2. Redistributions in binary form must reproduce the above copyright notice,
       this list of conditions and the following disclaimer in the documentation
       and/or other materials provided with the distribution.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
  DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
  FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
  SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/


#ifndef _GMRF_PROTO_BABEL_PACKET_H_
#define _GMRF_PROTO_BABEL_PACKET_H_

#include "types.h"

#include <alloca.h>

#include <arpa/inet.h>


#define GP_BABEL_VERSION 0


struct __attribute__((packed)) gp_babel_packet {
	uint16_t version;
	uint16_t len;
	uint8_t tlv[];
};

struct gp_babel_packet_buf {
	size_t max_len;
	gp_babel_packet_t packet;
};

#define gp_babel_packet_alloca(size) ({ \
			gp_babel_packet_buf_t *__buf = alloca(sizeof(gp_babel_packet_buf_t) + size - sizeof(gp_babel_packet_t)); \
			__buf->max_len = size - sizeof(gp_babel_packet_t); \
			__buf->packet.version = htons(GP_BABEL_VERSION); \
			__buf->packet.len = 0;				\
			__buf;						\
		})

static inline size_t gp_babel_packet_size(const gp_babel_packet_t *packet) {
	return sizeof(gp_babel_packet_t)+ntohs(packet->len);
}


#endif /* _GMRF_PROTO_BABEL_PACKET_H_ */
